/*global define*/
/*jslint vars: true, plusplus:true, browser: true*/
define([
    'testsuite/qunit',
    'jquery',
    'de_epages/presentation/rss',
    '$ready!'
], function (QUnit, $, de_epages) {
    'use strict';
    QUnit.module("de_epages/presentation/rss");

    QUnit.asyncTest("de_epages/presentation/rss", function () {
        var rss = new de_epages.presentation.Rss('../de_epages/presentation/rss-test-epagesblog.xml', function (data) {
            QUnit.ok(data.description.length === 254, 'description ok');

            QUnit.ok(data.items.length === 10, 'number of items ok');

            var items = data.items;
            var i;
            var iLength = items.length;
            for (i = 0; i < iLength; i++) {
                var item = items[i];

                QUnit.ok(item.link !== undefined, 'item ' + i + ' link defined');

                QUnit.ok(item.pubDate !== undefined, 'item ' + i + ' publish Date defined');

                QUnit.ok(item.text !== undefined, 'item ' + i + ' text defined');

                QUnit.ok(item.textEncoded !== undefined, 'item ' + i + ' text encoded defined');

                QUnit.ok(item.title !== undefined, 'item ' + i + ' title defined');
            }

            QUnit.ok(data.pubDate.getTime() === new Date('Fri, 07 Jan 2011 15:00:21 +0000').getTime(), 'publish date ok');

            QUnit.ok(data.version === 'RSS', 'version RSS ok');
        }, true);

        rss = new de_epages.presentation.Rss('../de_epages/presentation/rss-test-golem091.xml', function (data) {
            QUnit.ok(data.description.length === 19, 'description ok');

            QUnit.ok(data.items.length === 40, 'number of items ok');

            var items = data.items;
            var i;
            var iLength = items.length;
            for (i = 0; i < iLength; i++) {
                var item = items[i];

                QUnit.ok(item.link !== undefined, 'item ' + i + ' link defined');

                QUnit.ok(item.pubDate !== undefined, 'item ' + i + ' publish Date defined');

                QUnit.ok(item.text !== undefined, 'item ' + i + ' text defined');

                QUnit.ok(item.textEncoded !== undefined, 'item ' + i + ' text encoded defined');

                QUnit.ok(item.title !== undefined, 'item ' + i + ' title defined');
            }

            QUnit.ok(data.pubDate.getTime() === new Date('Tue, 11 Jan 2011 18:18:00 +0100').getTime(), 'publish date ok');

            QUnit.ok(data.version === 'RSS', 'version RSS ok');
        }, true);


        rss = new de_epages.presentation.Rss('../de_epages/presentation/rss-test-golem10.xml', function (data) {
            QUnit.ok(data.description.length === 19, 'description ok');

            QUnit.ok(data.items.length === 40, 'number of items ok');

            var items = data.items;
            var i;
            var iLength = items.length;
            for (i = 0; i < iLength; i++) {
                var item = items[i];

                QUnit.ok(item.link !== undefined, 'item ' + i + ' link defined');

                QUnit.ok(item.pubDate !== undefined, 'item ' + i + ' publish Date defined');

                QUnit.ok(item.text !== undefined, 'item ' + i + ' text defined');

                QUnit.ok(item.textEncoded !== undefined, 'item ' + i + ' text encoded defined');

                QUnit.ok(item.title !== undefined, 'item ' + i + ' title defined');
            }

            QUnit.ok(data.version === 'RDF', 'version RDF ok');
        }, true);


        rss = new de_epages.presentation.Rss('../de_epages/presentation/rss-test-golem20.xml', function (data) {
            QUnit.ok(data.description.length === 19, 'description ok');

            QUnit.ok(data.items.length === 40, 'number of items ok');

            var items = data.items;
            var i;
            var iLength = items.length;
            for (i = 0; i < iLength; i++) {
                var item = items[i];

                QUnit.ok(item.link !== undefined, 'item ' + i + ' link defined');

                QUnit.ok(item.pubDate !== undefined, 'item ' + i + ' publish Date defined');

                QUnit.ok(item.text !== undefined, 'item ' + i + ' text defined');

                QUnit.ok(item.textEncoded !== undefined, 'item ' + i + ' text encoded defined');

                QUnit.ok(item.title !== undefined, 'item ' + i + ' title defined');
            }

            QUnit.ok(data.pubDate.getTime() === new Date('Tue, 11 Jan 2011 18:18:00 +0100').getTime(), 'publish date ok');

            QUnit.ok(data.version === 'RSS', 'version RSS ok');
        }, true);


        rss = new de_epages.presentation.Rss('../de_epages/presentation/rss-test-golematom.xml', function (data) {
            QUnit.ok(data.description.length === 19, 'description ok');

            QUnit.ok(data.items.length === 40, 'number of items ok');

            var items = data.items;
            var i;
            var iLength = items.length;
            for (i = 0; i < iLength; i++) {
                var item = items[i];

                QUnit.ok(item.link !== undefined, 'item ' + i + ' link defined');

                QUnit.ok(item.pubDate !== undefined, 'item ' + i + ' publish Date defined');

                QUnit.ok(item.text !== undefined, 'item ' + i + ' text defined');

                QUnit.ok(item.textEncoded !== undefined, 'item ' + i + ' text encoded defined');

                QUnit.ok(item.title !== undefined, 'item ' + i + ' title defined');
            }

            QUnit.ok(data.pubDate.getTime() === new Date('Tue, 11 Jan 2011 19:15:07 +0100').getTime(), 'publish date ok');

            QUnit.ok(data.version === 'ATOM', 'version RSS ok');
        }, true);

        setTimeout(function () {
            QUnit.start();

        }, 500);
    });
});